package cn.com.infosec.crypto.generators;

import java.math.BigInteger;
import java.security.SecureRandom;

class DHParametersHelper {
   private static final BigInteger ONE = BigInteger.valueOf(1L);
   private static final BigInteger TWO = BigInteger.valueOf(2L);

   static BigInteger[] generateSafePrimes(int size, int certainty, SecureRandom random) {
      --size;

      BigInteger var10000;
      BigInteger var3;
      BigInteger var4;
      do {
         do {
            var10000 = var3 = new BigInteger;
            var10000.<init>(size, 2, random);
         } while(!(var4 = var10000.shiftLeft(1).add(ONE)).isProbablePrime(certainty));
      } while(certainty > 2 && !var3.isProbablePrime(certainty));

      return new BigInteger[]{var4, var3};
   }

   static BigInteger selectGenerator(BigInteger p, BigInteger q, SecureRandom random) {
      BigInteger var3 = p.subtract(TWO);

      BigInteger var4;
      BigInteger var5;
      do {
         while((var5 = createInRange(var4 = TWO, var3, random)).modPow(var4, p).equals(var4 = ONE)) {
         }
      } while(var5.modPow(q, p).equals(var4));

      return var5;
   }

   private static BigInteger createInRange(BigInteger min, BigInteger max, SecureRandom random) {
      BigInteger var10000;
      BigInteger var3;
      do {
         var10000 = var3 = new BigInteger;
         var3.<init>(max.bitLength(), random);
      } while(var10000.compareTo(min) < 0 || var3.compareTo(max) > 0);

      return var3;
   }
}
